package de.meinefirma.meinprojekt.backingbeans;

import java.util.*;
import javax.faces.bean.*;

// Backing Bean fuer auswahllisten.xhtml
@ManagedBean
@ViewScoped
public class AuswahllistenBean
{
   private static List<Produkt> produkte = new ArrayList<>();
   static {
      produkte.add( new Produkt( "lst", "Meine Abc-Liste", new String[] { "csv", "xml", "xls", "pdf" }, true ) );
      produkte.add( new Produkt( "rpt", "Mein XY-Report", new String[] { "doc", "pdf" }, true ) );
      produkte.add( new Produkt( "prs", "Meine Prsentation", new String[] { "ppt", "pdf" }, true ) );
      produkte.add( new Produkt( "img", "Meine bersichtsgrafik", new String[] { "jpg" }, false ) );
   }
   private Produkt produkt;
   private String  formatValue;
   private String  zipValue;

   public String getProduktId()
   {
      return ( produkt != null ) ? produkt.id : null;
   }

   public void setProduktId( String prodId )
   {
      for( Produkt prod : produkte ) {
         if( prod.id.equals( prodId ) ) {
            produkt = prod;
            break;
         }
      }
   }

   public List<Produkt> getListe1()
   {
      return produkte;
   }

   public String[] getListe2()
   {
      return ( produkt != null ) ? produkt.formate : new String[] { "zuerst Produkt auswhlen" };
   }

   public String getFormatValue()
   {
      return formatValue;
   }

   public void setFormatValue( String formatValue )
   {
      this.formatValue = formatValue;
   }

   public boolean getZipDisabled()
   {
      return produkt == null || !produkt.zipbar;
   }

   public String getZipValue()
   {
      if( getZipDisabled() ) { zipValue = "nein"; }
      return zipValue;
   }

   public void setZipValue( String zipValue )
   {
      this.zipValue = zipValue;
   }

   public boolean getSubmitDisabled()
   {
      return produkt == null;
   }

   public String submit()
   {
      System.out.println( "\nSubmit: Produkt=" + produkt.titel + ", Format=" + formatValue + ", Zip=" + zipValue );
      return null;
   }

   public String cancel()
   {
      System.out.println( "\nCancel" );
      return "auswahllisten.xhtml";
   }

   public static class Produkt
   {
      public String   id;
      public String   titel;
      public String[] formate;
      public boolean  zipbar;
      public Produkt( String id, String titel, String[] formate, boolean zipbar ) {
         this.id      = id;
         this.titel   = titel;
         this.formate = formate;
         this.zipbar  = zipbar;
      }
      public String getId()    { return id; }
      public String getTitel() { return titel; }
   }
}
