package de.meinefirma.meinprojekt.backingbeans;

import java.util.*;
import javax.faces.application.FacesMessage;
import javax.faces.bean.*;
import javax.faces.context.FacesContext;
import de.meinefirma.meinprojekt.entities.*;

/** Backing Bean, verknuepft die Daten und die Geschaeftslogik mit der JSF-View */
@ManagedBean
@ViewScoped
public class MeineBackingBean
{
   private List<MeineEntity> meineDatenListe;
   private MeineEntity einzelnesElement;

   public MeineBackingBean()
   {
      meineDatenListe = MeineEntityDao.findAll();

      // Erzeuge eine Daten-Vorbelegung fuer erste einfache Tests:
      if( meineDatenListe == null ) {
         meineDatenListe = MeineEntityDao.createTestDaten();
      }
   }

   public String elementLoeschen()
   {
      meineDatenListe = MeineEntityDao.findAll();
      if( meineDatenListe == null || einzelnesElement == null ) {
         addFacesMessage( FacesMessage.SEVERITY_ERROR, "Fehler: Datenelement fehlt." );
      } else if( !meineDatenListe.remove( einzelnesElement ) ) {
         addFacesMessage( FacesMessage.SEVERITY_ERROR, "Fehler: Datenelement existiert nicht mehr." );
      } else {
         MeineEntityDao.writeAll( meineDatenListe );
      }
      return null;
   }

   public void addFacesMessage( FacesMessage.Severity severity, String msg )
   {
      FacesMessage facesMsg = new FacesMessage( severity, msg, null );
      FacesContext.getCurrentInstance().addMessage( null, facesMsg );
   }

   public List<MeineEntity> getMeineDatenListe()  { return meineDatenListe; }
   public MeineEntity       getEinzelnesElement() { return einzelnesElement; }
   public void setMeineDatenListe(  List<MeineEntity> meineDatenListe ) { this.meineDatenListe = meineDatenListe; }
   public void setEinzelnesElement( MeineEntity einzelnesElement )      { this.einzelnesElement = einzelnesElement; }
}
