package de.meinefirma.meinprojekt.entities;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.Date;

/** Zu speichernde Daten, kann leicht zu JPA-@Entity erweitert werden */
public class MeineEntity implements Serializable
{
   private static final long serialVersionUID = 1L;
   // Technische id, soll unique sein (wie Primary Key):
   private Integer id;
   private String  bezeichnung;
   private Date    datum;

   public MeineEntity( int id, String bezeichnung, Date datum )
   {
      this.id = Integer.valueOf( id );
      this.bezeichnung = bezeichnung;
      this.datum = datum;
   }

   public Integer getId()          { return id; }
   public String  getBezeichnung() { return bezeichnung; }
   public Date    getDatum()       { return datum; }
   public void    setId(          Integer id )          { this.id = id; }
   public void    setBezeichnung( String  bezeichnung ) { this.bezeichnung = bezeichnung; }
   public void    setDatum(       Date    datum )       { this.datum = datum; }

   @Override
   public String toString()
   {
      return "{ id=" + id + ", bezeichnung=" + bezeichnung + ", datum=" + (new SimpleDateFormat( "yyyy-MM-dd" )).format( datum ) + " }";
   }

   @Override
   public boolean equals( Object obj )
   {
      if( this == obj ) { return true; }
      if( obj == null ) { return false; }
      if( getClass() != obj.getClass() ) { return false; }
      MeineEntity other = (MeineEntity) obj;
      if( id == null ) { return other.id == null; }
      return id.equals( other.id );
   }

   @Override
   public int hashCode()
   {
      return 31 + (( id == null ) ? 0 : id.hashCode());
   }
}
