package de.meinefirma.meinprojekt.backingbeans;

import java.util.List;
import javax.faces.bean.*;
import de.meinefirma.meinprojekt.entities.*;
import de.meinefirma.meinprojekt.pageddata.PagedDataList;

@ManagedBean
@ViewScoped
public class MeineBackingBean
{
   private static final int DEFAULT_ROWS_PER_PAGE = 10;
   private static final int DEFAULT_ANZAHL_TESTDATEN = 500;
   private PagedDataList<MeineEntity> pagedDataList;

   public MeineBackingBean()
   {
      MeineEntityDao dao = new MeineEntityDao();
      dao.createTestDataIfNoData( DEFAULT_ANZAHL_TESTDATEN );
      pagedDataList = new PagedDataList<>( dao, DEFAULT_ROWS_PER_PAGE );
   }

   public PagedDataList<MeineEntity> getPagedDataList() { return pagedDataList; }
   public List<MeineEntity> getSortableEntities() { return pagedDataList.getSortableEntities(); }
   public int     getRowsPerPage()  { return pagedDataList.getRowsPerPage(); }
   public String  getSortColumn()   { return pagedDataList.getSortColumn(); }
   public boolean isSortAscending() { return pagedDataList.isSortAscending(); }
   public void setSortColumn(    String  sortColumn    ) { pagedDataList.setSortColumn(    sortColumn ); }
   public void setSortAscending( boolean sortAscending ) { pagedDataList.setSortAscending( sortAscending ); }
}
