package de.meinefirma.meinprojekt.entities;

import java.util.*;
import javax.persistence.*;
import de.meinefirma.meinprojekt.pageddata.PagedDataReader;

public class MeineEntityDao implements PagedDataReader<MeineEntity>
{
   EntityManagerFactory emf = Persistence.createEntityManagerFactory( "MeineJpaPU" );

   @Override
   public int getRowsCountAll()
   {
      EntityManager em = emf.createEntityManager();
      Query query = em.createNativeQuery( "Select count(*) from MeineEntity" );
      return ((Integer) query.getSingleResult()).intValue();
   }

   @Override
   @SuppressWarnings("unchecked")
   public List<MeineEntity> readPageOfData( String sortColumn, boolean sortAscending, int firstRowIndex, int rowsPerPage )
   {
      EntityManager em = emf.createEntityManager();
      Query query = em.createQuery( "Select e from MeineEntity e order by e." +
                                     (( sortColumn != null && !sortColumn.isEmpty() ) ? sortColumn.toLowerCase() : "id") +
                                     (( sortAscending ) ? " asc" : " desc") );
      query.setFirstResult( firstRowIndex );
      query.setMaxResults( rowsPerPage );
      return query.getResultList();
   }

   public void createTestDataIfNoData( int anzahl )
   {
      List<MeineEntity>  lst0 = readPageOfData( null, true, 0, 1 );
      if( lst0 != null && !lst0.isEmpty() ) { return; }

      Random rndm = new Random();
      for( int i = 0; i < anzahl; i++ ) {
         int i1 = rndm.nextInt( 26 );
         int i2 = rndm.nextInt( 26 );
         String s = String.valueOf( new char[] { (char) ('A' + i1), (char) ('A' + i2) } );
         createEntity( new MeineEntity(  s, new Date() ) );
      }
   }

   public <T> void createEntity( T entity )
   {
      EntityManager     em = emf.createEntityManager();
      EntityTransaction tx = em.getTransaction();
      try {
         tx.begin();
         em.persist( entity );
         tx.commit();
      } catch( RuntimeException ex ) {
         if( tx != null && tx.isActive() ) tx.rollback();
         throw ex;
      } finally {
         em.close();
      }
   }
}
